build.sh 10 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264
  1. #!/bin/bash
  2. # (c) 2014-2016 Freifunk Hochstift <kontakt@hochstift.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  10. #
  11. # optional:
  12. # AUTOUPDATER = force Autoupdater Branch (stable/testing/experimental/off)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  15. # DIRCLEAN = 1 perform "make dirclean" before build (BRANCH==stable/testing) or 0 perform "make clean" (BRANCH==experimental)
  16. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  17. # PRIORITY = determines the number of day a rollout phase should last at most
  18. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  19. # SITE_REPO_FETCH_METHOD = http, everything except "git" will use the HTTP method for fetchting site repo
  20. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  21. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  22. #
  23. # expert/special usecase only (optional):
  24. # FAKETIME_LIB = path to libfaketime.so.1 if it is not in the standard location
  25. # NO_FAKETIME = 0 (default) or 1, disables the use of Faketime
  26. ### includes
  27. . functions.sh
  28. ### static variables
  29. MY_DIR=$(dirname $0)
  30. MY_DIR=$(readlink -f "${MY_DIR}")
  31. CODE_DIR="${MY_DIR}/src"
  32. SITE_DIR="${CODE_DIR}/site"
  33. PATCH_DIR="${SITE_DIR}/patches"
  34. OUTPUT_DIR="${MY_DIR}/output"
  35. IMAGE_DIR="${CODE_DIR}/output/images"
  36. MODULE_DIR="${CODE_DIR}/output/modules"
  37. VERSIONS_INFO_DIR="${MY_DIR}/versions"
  38. BUILD_INFO_FILENAME="build-info.txt"
  39. SITE_REPO_URL="git.c3pb.de/freifunk-pb/site-ffho.git"
  40. LANG=C
  41. pushd ${MY_DIR} > /dev/null
  42. ### ERROR handling
  43. [ -n "${BASE}" ] || abort "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)."
  44. [ -n "${BRANCH}" ] || abort "Please specify BRANCH environment variable."
  45. [ "${BRANCH}" == "experimental" -o "${BASE}" != "HEAD" ] || abort "HEAD is not an allowed BASE-identifier for non-experimental builds. Either use a tagged commit or the commit-SHA itself."
  46. [ -n "${VERSION}" -o "${BRANCH}" == "experimental" ] || abort "Please specify VERSION environment variable (not necessary for experimental branch)."
  47. [ "${BRANCH}" == "experimental" -o ! -r "${VERSIONS_INFO_DIR}/${VERSION}" ] || abort "There exists a version file for '${VERSION}' ... you are trying to do something really stupid, aren't you?"
  48. ### set reasonable defaults for unset environment variables
  49. [ -n "${AUTOUPDATER}" ] || AUTOUPDATER=${BRANCH}
  50. # TODO: [ "${BASE}" == "master" ] && BASE="origin/master"
  51. if [ -n "${BROKEN}" ]; then
  52. if [ "${BROKEN}" -eq "1" ]; then
  53. export BROKEN
  54. else
  55. unset BROKEN
  56. fi
  57. fi
  58. [ -n "${BUILD_TS}" ] || BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  59. if [ -z "${DIRCLEAN}" ]; then
  60. if [ "${BRANCH}" == "experimental" ]; then
  61. DIRCLEAN=0
  62. else
  63. DIRCLEAN=1
  64. fi
  65. fi
  66. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  67. [ -n "${NO_FAKETIME}" ] || NO_FAKETIME=0
  68. [ -n "${PRIORITY}" ] || PRIORITY=0
  69. [ -n "${SITE_REPO_FETCH_METHOD}" ] || SITE_REPO_FETCH_METHOD="http"
  70. [ -n "${VERBOSE}" ] || VERBOSE=0
  71. if [ "${SITE_REPO_FETCH_METHOD}" != "git" ]; then
  72. SITE_REPO_URL="https://${SITE_REPO_URL}"
  73. else
  74. SITE_REPO_URL="git@${SITE_REPO_URL}"
  75. fi
  76. MAKE_PARAM=""
  77. [ "${VERBOSE}" -eq "1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  78. ### INIT /src IF NECESSARY
  79. if [ ! -d "${CODE_DIR}" ]; then
  80. info "Code directory does not exist yet - fetching Gluon ..."
  81. git clone https://github.com/freifunk-gluon/gluon.git "${CODE_DIR}"
  82. [ "$?" -eq "0" ] || abort "Failed to fetch Gluon repository."
  83. fi
  84. ### INIT /src/site IF NECESSARY
  85. if [ ! -d "${SITE_DIR}" ]; then
  86. info "Site repository does not exist, fetching it ..."
  87. git clone "${SITE_REPO_URL}" "${SITE_DIR}"
  88. [ "$?" -eq "0" ] || abort "Failed to fetch SITE repository."
  89. fi
  90. pushd ${CODE_DIR} > /dev/null
  91. ### CHECKOUT GLUON
  92. progress "Checking out GLUON '${BASE}' ..."
  93. # TODO: check if gluon got modified and bail out if necessary
  94. git fetch
  95. git checkout -q ${BASE}
  96. [ "$?" -eq "0" ] || abort "Failed to checkout '${BASE}' gluon base version, mimimi." >&2
  97. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  98. ### CHECKOUT SITE REPO
  99. progress "Checking out SITE REPO ..."
  100. pushd ${SITE_DIR} > /dev/null
  101. # TODO: check if site got modified locally and bail out if necessary
  102. if [ -z "${SITE_ID}" ]; then
  103. # no specific site given - get the most current one
  104. git checkout -q ${BRANCH} ; git pull
  105. [ "$?" -eq "0" ] || abort "Failed to get newest '${BRANCH}' in site repository, mimimi."
  106. else
  107. # fetch site repo updates
  108. git fetch || true
  109. # commit given - use this one
  110. git checkout -q ${SITE_ID}
  111. [ "$?" -eq "0" ] || abort "Failed to checkout requested site commit '${SITE_ID}', mimimi."
  112. fi
  113. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  114. popd > /dev/null #${SITE_DIR}
  115. ### APPLY PATCHES TO GLUON
  116. progress "Applying Patches ..."
  117. git checkout -B patching "${BASE}"
  118. if [ "$(echo "${PATCH_DIR}"/*.patch)" ]; then
  119. git am ${PATCH_DIR}/*.patch || (
  120. git am --abort
  121. git checkout patched
  122. git branch -D patching
  123. false
  124. )
  125. [ "$?" -eq "0" ] || abort "Failed to apply patches, mimimi."
  126. fi
  127. git branch -M patched
  128. ### DIRCLEAN
  129. if [ -d "./build/" -a "${DIRCLEAN}" -eq "1" ]; then
  130. progress "Cleaning your build environment ..."
  131. make dirclean
  132. fi
  133. ### PREPARE
  134. progress "Preparing the build environment (make update) ..."
  135. make update
  136. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  137. popd > /dev/null #${CODE_DIR}
  138. ### set reasonable defaults for ${TARGETS} and ${BRANCH} if unset
  139. if [ -z "${TARGETS}" ]; then
  140. TARGETS=$(make list-targets | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
  141. info "building all tagets: '${TARGETS}'"
  142. fi
  143. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  144. VERSION=$(make default-release)
  145. info "EXPERIMENTAL FIRMWARE: using version tag '${VERSION}'"
  146. fi
  147. # we are now ready to produce the firmware images, so let's "save" our state
  148. build_info_path="${OUTPUT_DIR}/${BRANCH}/${BUILD_INFO_FILENAME}"
  149. progress "Saving build information to: ${build_info_path}"
  150. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  151. mkdir -p $(dirname ${build_info_path})
  152. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  153. touch $(dirname ${build_info_path})
  154. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  155. echo "VERSION=${VERSION}" >> ${build_info_path}
  156. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  157. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  158. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  159. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  160. echo "TS=${BUILD_TS}" >> ${build_info_path}
  161. ### SETUP FAKETIME (consistent build)
  162. if [ "${NO_FAKETIME}" -eq "0" ]; then
  163. [ -z "${FAKETIME_LIB}" ] && FAKETIME_LIB="/usr/lib/${MACHTYPE}-${OSTYPE}/faketime/libfaketime.so.1"
  164. export LD_PRELOAD="${FAKETIME_LIB}"
  165. export FAKETIME="${BUILD_TS}"
  166. fi
  167. ### BUILD FIRMWARE
  168. progress "Building the firmware - please stand by!"
  169. pushd ${CODE_DIR} > /dev/null
  170. for target in ${TARGETS} ; do
  171. # configure build environment for our current target
  172. export GLUON_TARGET="${target}"
  173. export GLUON_RELEASE="${VERSION}"
  174. [ "${AUTOUPDATER}" != "off" ] && export GLUON_BRANCH="${AUTOUPDATER}"
  175. # prepare build environment for our current target
  176. progress "Preparing build environment for target ${target}."
  177. [ "${DIRCLEAN}" -eq "0" ] && make clean
  178. [ "$?" -eq "0" ] || abort "Unable to clean environment for target-platform ${target}."
  179. make -j ${MAKEJOBS} prepare-target ${MAKE_PARAM}
  180. [ "$?" -eq "0" ] || abort "Unable to build environment for target-platform ${target}."
  181. # need to have a toolchain for the particular target
  182. progress "Building toolchain for target ${target}."
  183. make -j ${MAKEJOBS} toolchain/install ${MAKE_PARAM}
  184. [ "$?" -eq "0" ] || abort "Unable to build toolchain for target-platform ${target}."
  185. # now we can start building the images for the target platform
  186. progress "Building FFHO-flavoured Gluon firmware for target ${target}. You'd better go and fetch some c0ffee!"
  187. make -j ${MAKEJOBS} prepare ${MAKE_PARAM}
  188. [ "$?" -eq "0" ] || abort "Failed to build firmware for target-platform ${target}."
  189. # finally compile the firmware binaries
  190. progress "Compiling binary firmware images."
  191. make -j ${MAKEJOBS} images ${MAKE_PARAM}
  192. [ "$?" -eq "0" ] || abort "Failed to assemble images for target-platform ${target}."
  193. # compile the modules
  194. progress "Compiling modules."
  195. make -j ${MAKEJOBS} modules ${MAKE_PARAM}
  196. [ "$?" -eq "0" ] || abort "Failed to build modules for target-platform ${target}."
  197. done
  198. popd > /dev/null #${CODE_DIR}
  199. # compress all binaries into 7z archive
  200. progress "Assembling images.7z ..."
  201. pushd ${IMAGE_DIR} > /dev/null
  202. [ -e "${OUTPUT_DIR}/${BRANCH}/images.7z" ] && rm "${OUTPUT_DIR}/${BRANCH}/images.7z"
  203. 7z a -mmt=on -xr!*.manifest "${OUTPUT_DIR}/${BRANCH}/images.7z" ./sysupgrade/* ./factory/*
  204. [ "$?" -eq "0" ] || abort "Failed to assemble images (did you install p7zip-full?)."
  205. popd > /dev/null #${IMAGE_DIR}
  206. # compress modules into 7z archive
  207. progress "Assembling modules.7z ..."
  208. pushd ${MODULE_DIR} > /dev/null
  209. [ -e "${OUTPUT_DIR}/${BRANCH}/modules.7z" ] && rm "${OUTPUT_DIR}/${BRANCH}/modules.7z"
  210. 7z a -mmt=on "${OUTPUT_DIR}/${BRANCH}/modules.7z" ./* > /dev/null
  211. [ "$?" -eq "0" ] || abort "Failed to assemble modules."
  212. popd > /dev/null #${MODULE_DIR}
  213. # generate and copy manifests
  214. progress "Generating and copying manifest ..."
  215. pushd ${CODE_DIR} > /dev/null
  216. GLUON_PRIORITY=${PRIORITY} GLUON_BRANCH=${BRANCH} make manifest
  217. [ "$?" -eq "0" ] || abort "Failed to generate the manifest, try running 'make manifest' in '$CODE_DIR' directory manually."
  218. cp "${CODE_DIR}/output/images/sysupgrade/${BRANCH}.manifest" "${OUTPUT_DIR}/${BRANCH}/"
  219. popd > /dev/null #${CODE_DIR}
  220. # Saving a copy of the build info file as reference
  221. progress "Building a greater and brighter firmware finished successfully. Saving build information at: ${VERSIONS_INFO_DIR}/${VERSION}"
  222. cp -p "${build_info_path}" "${VERSIONS_INFO_DIR}/${VERSION}"
  223. # The end. Finally.
  224. success "We're done, go and enjoy your new firmware in ${OUTPUT_DIR}/${BRANCH}!"
  225. popd > /dev/null #${MY_DIR}